using FarPoint.Win.Spread;
using System.Data;

namespace RangeClear
{
    public partial class Form1 : Form
    {
        private FpSpread fp = new FpSpread() { Dock = DockStyle.Left, Width = 600 };
        private DataTable _dtSource1;
        private DataTable _dtSource2;

        public Form1()
        {
            InitializeComponent();
            CreateDataSource();
            fp.Sheets.Add(new SheetView() { });
        }

        public void CreateDataSource()
        {
            _dtSource1 = new DataTable("Table1");
            _dtSource1.Columns.Add("Cabinet", typeof(string));
            _dtSource1.Columns.Add("Quantity", typeof(int));
            _dtSource1.Columns.Add("Value", typeof(double));

            DataRow dr = default(DataRow);
            dr = _dtSource1.NewRow();
            dr[0] = "V";
            dr[1] = 11;
            dr[2] = 413.156d;
            _dtSource1.Rows.Add(dr);


            dr = _dtSource1.NewRow();
            dr[0] = "W";
            dr[1] = 31;
            dr[2] = 1528.417d;
            _dtSource1.Rows.Add(dr);

            dr = _dtSource1.NewRow();
            dr[0] = "X";
            dr[1] = 18;
            dr[2] = 52.6d;
            _dtSource1.Rows.Add(dr);

            dr = _dtSource1.NewRow();
            dr[0] = "Y";
            dr[1] = 3;
            dr[2] = 52.6d;
            _dtSource1.Rows.Add(dr);

            dr = _dtSource1.NewRow();
            dr[0] = "Z";
            dr[1] = 2;
            dr[2] = 330d;
            _dtSource1.Rows.Add(dr);

            _dtSource2 = new DataTable("Table2");
            _dtSource2.Columns.Add("Cabinet", typeof(string));
            _dtSource2.Columns.Add("Profit", typeof(double));
            _dtSource2.Columns.Add("Price", typeof(double));

            dr = _dtSource2.NewRow();
            dr[0] = "A";
            dr[1] = 50.33d;
            dr[2] = 600.42d;
            _dtSource2.Rows.Add(dr);

            dr = _dtSource2.NewRow();
            dr[0] = "B";
            dr[1] = 130.33d;
            dr[2] = 2000.42d;
            _dtSource2.Rows.Add(dr);

            dr = _dtSource2.NewRow();
            dr[0] = "C";
            dr[1] = 43.43d;
            dr[2] = 139.23d;
            _dtSource2.Rows.Add(dr);

            dr = _dtSource2.NewRow();
            dr[0] = "D";
            dr[1] = 16.33d;
            dr[2] = 139.23d;
            _dtSource2.Rows.Add(dr);

            dr = _dtSource2.NewRow();
            dr[0] = "E";
            dr[1] = 60.43d;
            dr[2] = 19.23d;
            _dtSource2.Rows.Add(dr);

            dr = _dtSource2.NewRow();
            dr[0] = "F";
            dr[1] = 70.33d;
            dr[2] = 20.23d;
            _dtSource2.Rows.Add(dr);

            dr = _dtSource2.NewRow();
            dr[0] = "G";
            dr[1] = 132.32d;
            dr[2] = 500.23d;
            _dtSource2.Rows.Add(dr);
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            SetDataSourceToSheet();
            tabControl1.SelectedIndexChanged += TabControl1_SelectedIndexChanged;
        }

        public void SetDataSourceToSheet()
        {
            if (tabControl1.SelectedIndex == 0)
            {
                tabPage1.Controls.Add(fp);                
                fp.DataSource = _dtSource2;
            }
            else
            {
                tabPage2.Controls.Add(fp);
                fp.DataSource = _dtSource1;
            }
        }

        private void TabControl1_SelectedIndexChanged(object? sender, EventArgs e)
        {
            SetDataSourceToSheet();
        }

        private void sortBtn_Click(object sender, EventArgs e)
        {
            // sorting row index 1 to 4 based on column index 1
            fp.ActiveSheet.SortRows(1, 4, new SortInfo[] { new SortInfo(1, true) });
        }
    }
}